; *********************************
function heaviside,x
y = (x gt 0)*1D + ((x lt 0))*0D + 0.5D*(x eq 0)
return,y
end
; *********************************
function rect,x,b,h
; b: base (width) of the rectangle
; h: height of the rectangle
r = h*(heaviside(x+0.5*b)-heaviside(x-0.5*b))
return,r
end
; *********************************
pro convolution_example
nx = 101
x = makepts(xlo = -5.0,xhi = 5.0,npts = nx)
dx = x[1] - x[0]
base = 2.0 & height = 1.0
kernel = rect(x+0.5,1.0,2.0)+rect(x-0.5,1.0,1.0)
array = gaussian(x,area = 1.0,center = 0.0,fwhm = 0.35)
nlo = 3 & nhi = nx-nlo-1
plot,x,array,yrange = [0.0,3.0],/ysty,linestyle = 2, $
   title = '!3Convolution Example 5',xrange = [-3.0,3.0],/xsty
oplot,x,kernel,linestyle = 0
ycon1 = convol(array,reverse(kernel[nlo:nhi]),/edge_truncate)*dx
oplot,x,ycon1,thick = 4.0,color = black
end