;+
; RSI TRAINING FILE HEADER
; FILE: checkdecompose.pro
; ROUTINE: checkdecompose
; PURPOSE: check the decompose state and query user to change
; TOPICS: colors in IDL
; CLASS: Intro/Intermediate
; REFERENCE: IDL Tour, Color chapter
; LAST MODIFIED: 09/30/99 - BL
; USAGE:checkdecompose
;-

PRO checkdecompose, OLD_DC = oldDC

;compile_opt hidden
;compile_opt idl2

; check decompose state
device, get_decompose = oldDC
if (oldDC eq 1) then begin
	msg = ['---- WARNING -----', $
		   'decompose color is on', $
		   '24-bit (TrueColor) indexing is in effect', $
		   'CINDEX displays information about 8-bit (PseudoColor) color tables', $
		   'All Color tables will display as shades of red', $
		   ' ', $
		   'Should device, decompose = 0 be set?']
   	ans = dialog_message(msg, /QUESTION)
   	if (strupcase(ans) eq 'YES') then device, decompose = 0
endif

END
