; ***************************** ;
pro widget_ex_1_event,event
; This is the main event handler.
; Since there is only a single widget
; except for the base, there is only one
; event type that can occur and transfer program
; control to this handler.  So no matter
; what we will know that this is a
; QUIT button event.  Therefore we simply
; destroy the widget hierarchy.
print,tag_names(event,/structure_name)
print,tag_names(event)
widget_control,event.id,get_value = widget_value
print,'Widget_value: ',widget_value
widget_control,event.top,/destroy
end
; ***************************** ;
pro widget_ex_1
; This is a first widget example
;
; Create the top-level base
tlb = widget_base(/col,title = 'First Widget')
; Create a QUIT button on the top-level base
quit = widget_button(tlb,value = 'QUIT',xsize = 200)
; Render the widgets on the screen
widget_control,tlb,/realize
; Start up the XMANAGER which manages the
; widget events
xmanager,'widget_ex_1',tlb,   $
   event_handler = 'widget_ex_1_event',/no_block

end