; ***************************** ;
pro wex3_cleanup,tlb
widget_control,tlb,get_uvalue = pstate
wdelete,(*pstate).winpix
ptr_free,pstate
end
; ***************************** ;
pro wex3_plot_rand,event
widget_control,event.top,get_uvalue = pstate
plot,(*pstate).data,psym = -4,   $
   title = (*pstate).plot_title
end
; ***************************** ;
pro wex3_plot_refresh,event
widget_control,event.top,get_uvalue = pstate
wset,(*pstate).winpix
wex3_plot_rand,event
wset,(*pstate).winvis
device,copy = [0,0,!d.x_size,!d.y_size,0,0, $
               (*pstate).winpix]
end
; ***************************** ;
pro wex3_win_events,event
widget_control,event.top,get_uvalue = pstate
coords = convert_coord(event.x,event.y,   $
   /device,/to_data)
x = 49 < (round(coords[0]) > 0)
y = ((*pstate).data)[x]
; Update the title to include the latest position
; of the mouse (nearest to the data)
(*pstate).plot_title = $
      strtrim(string(x,format = '(I3)'),2)+   $
      ','+strtrim(string(y,format = '(f15.5)'),2)
wex3_plot_refresh,event
; Plot a thick symbol at the current closest
; data point.
plots,x,y,psym = 4,thick = 4.0,/data
end
; ***************************** ;
pro wex3_rand_events,event
widget_control,event.top,get_uvalue = pstate
(*pstate).data = randomn(s,50)
wex3_plot_refresh,event
end
; ***************************** ;
pro wex3_event,event
uname = widget_info(event.id,/uname)
case uname of
'QUIT':  widget_control,event.top,/destroy
'WIN':   wex3_win_events,event
'RAND':  wex3_rand_events,event
else:
endcase
end
; ***************************** ;
pro widget_ex_3,group_leader = group_leader
if n_elements(group_leader) eq 0 then group_leader = 0L
if xregistered('widget_ex_3') then return
tlb = widget_base(/row,title = '',group_leader = group_leader)
col_base = widget_base(tlb,/col)
void = widget_button(col_base,value = 'Randomize', $
   uname = 'RAND')
void = widget_button(col_base,value = 'Quit',      $
   uname = 'QUIT')
win = widget_draw(tlb,xsize = 300,ysize = 300,  $
   /motion_events,uname = 'WIN')

widget_control,tlb,/realize
widget_control,win,get_value = winvis
window,/free,/pixmap,xsize = 300,ysize = 300
winpix = !d.window
data = randomn(s,50)

state =  {  winvis:winvis,             $
            winpix:winpix,             $
            plot_title:'',             $
            data:data                  }
pstate = ptr_new(state)
widget_control,tlb,set_uvalue = pstate

xmanager,'widget_ex_3',tlb,/no_block,     $
   event_handler = 'wex3_event',   $
   cleanup = 'wex3_cleanup'

; Create a pseudo-event so that we can use
; the plot refresh event handler to plot
; the data in the window
pevent = {event,id:win,top:tlb,handler:0L}
wex3_plot_refresh,pevent
end